package com.io.yutian.aulib.nbt;

public class NBTFloat extends NBTNumber {

    public static byte TYPE_ID = 5;

    private float value;

    public NBTFloat(float value) {
        this.value = value;
    }

    @Override
    public Object getValue() {
        return this.value;
    }

    @Override
    public byte getTypeId() {
        return TYPE_ID;
    }

    @Override
    public long getLong() {
        return (long) this.value;
    }

    @Override
    public int getInt() {
        return floor(this.value);
    }

    @Override
    public short getShort() {
        return (short)(floor(this.value) & 0xFFFF);
    }

    @Override
    public byte getByte() {
        return (byte)(floor(this.value) & 0xFF);
    }

    @Override
    public double getDouble() {
        return this.value;
    }

    @Override
    public float getFloat() {
        return this.value;
    }

    @Override
    public String toString() {
        return "NBTFloat{" +
                "value=" + value +
                '}';
    }
}
