package com.io.yutian.aulib.nbt;

import java.util.ArrayList;
import java.util.List;

public class NBTList<T extends INBT> implements INBT {

    public static byte TYPE_ID = 9;

    private List<T> value = new ArrayList<>();
    private byte type = 0;

    public NBTList(List<T> value) {
        this.value = value;
    }

    public NBTList() {
    }

    public List<T> getList() {
        return value;
    }

    public int size() {
        return value.size();
    }

    public T get(int index) {
        if (index > value.size()) {
            return null;
        }
        return value.get(index);
    }

    public void add(T nbtBase) {
        if (nbtBase.getTypeId() == 0) {
            return;
        }
        if (this.type == 0) {
            this.type = nbtBase.getTypeId();
        } else if (this.type != nbtBase.getTypeId()) {
            return;
        }
        this.value.add(nbtBase);
    }

    public void remove(int index) {
        this.value.remove(index);
    }

    public boolean isEmpty() {
        return value.isEmpty();
    }

    @Override
    public Object getValue() {
        return this.value;
    }

    @Override
    public byte getTypeId() {
        return TYPE_ID;
    }

    public byte getType() {
        return type;
    }

    @Override
    public String toString() {
        return "NBTList{" +
                "value=" + value +
                ", type=" + type +
                '}';
    }

}
