package com.io.yutian.aulib.util;

import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.TextComponent;

public class TextComponentBuilder {

    private TextComponent textComponent;

    public TextComponentBuilder() {
        this.textComponent = new TextComponent();
    }

    public TextComponentBuilder addText(String text) {
        textComponent.addExtra(text);
        return this;
    }

    public TextComponentBuilder addText(String text, ClickEvent clickEvent) {
        TextComponent component = new TextComponent(text);
        component.setClickEvent(clickEvent);
        this.textComponent.addExtra(component);
        return this;
    }

    public TextComponentBuilder addText(String text, ClickEvent clickEvent, HoverEvent hoverEvent) {
        TextComponent component = new TextComponent(text);
        component.setClickEvent(clickEvent);
        component.setHoverEvent(hoverEvent);
        this.textComponent.addExtra(component);
        return this;
    }

    public TextComponentBuilder addText(String text, HoverEvent hoverEvent) {
        TextComponent component = new TextComponent(text);
        component.setHoverEvent(hoverEvent);
        this.textComponent.addExtra(component);
        return this;
    }

    public TextComponent build() {
        return textComponent;
    }
}
